<?php
/******************************************************************************
 *
 * Subrion - open source content management system
 * Copyright (C) 2014 Intelliants, LLC <http://www.intelliants.com>
 *
 * This file is part of Subrion.
 *
 * Subrion is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subrion is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Subrion. If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * @link http://www.subrion.org/
 *
 ******************************************************************************/

class iaCaptcha extends abstractUtil
{
	// Get a key from http://www.capinno.ru
	protected $_publicKey = '';
	protected $_privateKey = '';

	protected $_theme;

	protected $_error;


	public function __construct()
	{
		parent::init();

		require_once dirname(__FILE__) . IA_DS . '..' . IA_DS . 'capinno' . IA_DS . 'cap4a_lib.php';

		$this->_publicKey = $this->iaCore->get('capinno_publickey');
		$this->_privateKey = $this->iaCore->get('capinno_privatekey');
		$this->_theme = $this->iaCore->get('capinno_theme');
	}

	public function getImage()
	{
		if (!$this->_publicKey || !$this->_privateKey)
		{
			return iaLanguage::get('capinno_set_configuration');
		}

		$return = <<<CODE
<script type="text/javascript" src="http://part.cap4a.com/js/challenge.js?k={$this->_publicKey}"></script>
<noscript>
	<iframe src="http://part.cap4a.com/noscript.jsp?k={$this->_publicKey}" height="300" width="500" frameborder="0"></iframe><br>
	<textarea name="cap4a_challenge_field" rows="3" cols="40"></textarea>
	<input type="hidden" name="cap4a_response_field" value="manual_challenge">
</noscript>
CODE;

		return $return;
	}

	public function validate()
	{
		$response = cap4a_check_answer("", $this->_privateKey, $_SERVER['REMOTE_ADDR'], $_POST['cap4a_challenge_field'], $_POST['cap4a_response_field']);

		if ($response->is_valid)
		{
			return true;
		}

		return false;
	}

	public function getPreview()
	{
		return $this->getImage();
	}
}